%
% This file is used in  
%   https://gitlab.inria.fr/line/aide-group/aide/-/blob/master/etc/tex_to_pdf.sh
% and command are documented in http://aide-line.inria.fr/build/www/etc.html#.tex_to_pdf
%

% Defines a minimal layout for pdf display

\documentclass[a4paper,12pt,landscape,pdftoolbar=false,pdfmenubar=false]{article}
\pagestyle{empty} 
\topmargin 0cm \oddsidemargin 0cm \evensidemargin 0cm 
\setlength{\parindent}{0in} 
\setlength{\parskip}{3mm} 
\usepackage[margin=2cm]{geometry}

% Here are the used packages

\usepackage[utf8]{inputenc}
\DeclareUnicodeCharacter{00B0}{\textsuperscript{o}}

\usepackage{hyperref}
\usepackage{graphicx}
\usepackage{amsmath}\usepackage{amssymb}\usepackage{amsfonts}
\usepackage{array}
\usepackage{times}
\usepackage{color}
%\usepackage{algpseudocode}\usepackage{algorithm}
\usepackage{listings}

% Here is tha macro for conditional compilation

\def\aidebuild {}

% Here are some used commands

\newcommand{\deq}{\stackrel {\rm def}{=}} 
\newcommand{\eqline}[1]{~\vspace{0.3cm}\\\centerline{$#1$}\vspace{0.3cm}\\}
\newcommand{\tab}{\hphantom{6mm}}
\newcommand{\hhref}[1]{\href{#1}{#1}}

% Here are some homemade commands to define minimal slides

\newcommand{\slide}[2]{\clearpage\fbox{\parbox[t][16.5cm][t]{\textwidth}{\vspace{0.5cm}\centerline{\fontsize{40}{50}\selectfont {\bf #1}}\vspace{0.2cm}\huge~\\~{#2}}}\newpage}
\newcommand{\sitem}[1]{\\$\bullet$ {#1}}
\newcommand{\ssitem}[1]{\\\tab- {#1}}
\newcommand{\sfbox}[1]{\framebox[\textwidth]{{#1}}}
\newcommand{\sright}[1]{\begin{flushright}#1\tab\end{flushright}}
\newcommand{\scenter}[1]{\begin{center}#1\end{center}}
\newcommand{\stwo}[4]{\begin{tabular}{ll}\parbox{#1\textwidth}{#3}&\parbox{#2\textwidth}{#4}\end{tabular}}
\newcommand{\sappendix}{\appendix\clearpage\parbox[t][16.5cm][t]{\textwidth}{\vspace{8cm}\centerline{\fontsize{40}{50}\selectfont {\bf Appendix}}}}

\begin{document}
\subsection*{Implementing a reservoir transform}

In this context, a reservoir is a recurrent network of the form:

\centerline{\includegraphics[width=0.4\textwidth]{./recurrent-architecture.png}}

with recurrent equation\footnote{Using reservoir computing notations we read, in matrix form:
\eqline{
\mathbf{y}[t] = W_{out} \cdot \mathbf{x}[t] \;\;\;
\mathbf{x}[t+1] = l \, \mathbf{x}[t] + (1 - l) \, \sigma\left(\mathbf{W}_{in} \cdot \mathbf{u}[t+1] + \mathbf{W} \cdot \mathbf{x}[t]\right)}
which are equivalent with $y_o[t] \equiv x_{o}(t)$ and $x_n[t] \equiv x_{N_o+n}(t)$.}:
\eqline{\left\{ \begin{array}{rcll}
    x_o(t) &=&  \sum_{n \in \{N_0, N\{} W_{on}^{\mbox{o}} \, x_n(t)  & o < N_o \\
    x_n(t) &=& l \, x_n(t-1) + (1 - l) \, \sigma\left(\sum_{m = \{N_0, N\{} W_{nm} \, x_m(t-1) + \sum_{m = \{0, N_i\{} W_{ni}^{\mbox{i}} \, i_n(t)\right) & N_o \le n < N \\
\end{array}\right.}
writing:
\\ - $\sigma(\cdot)$ the normalized (i.e., $\sigma'(0) = 1$) sigmoid function $\sigma(x) \deq {1 \over 1 + \exp(-4 \, x)}$,
\\ - $W_{on}^{\mbox{o}}$ for the output weights,
\\ - $W_{ni}^{\mbox{i}}$ for the input weights,
\\ - $W_{nm}$ for the internal recurrent weights.
  
\end{document}
